
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《Python面向对象编程指南》——1.5　通过工厂函数调用__init()__ / iVAN</title>

    <meta name="description" content="《Python面向对象编程指南》——1.5　通过工厂函数调用__init()__ 1.5 通过工厂函数调用__init()__ 我们可以使用工厂函数来完成所有Card对象的创建,这比枚举52张牌的方式好很多.在Python中,实现工厂有两种途径. 定义一个函数,返回不同类的对象. 定义一个类,包含了创建对象的方法.这是完整的工厂设计模式,正如设计模式书中提到的.在类似Java这样的语言里,工厂类层次结构是必需的,因为语言本身不支持可以脱离类而单独存在的函数. 在Python里,类定义不是必需的.仅当特别复杂的情形,工厂类才是不错的选择.Python的优势之一是,对于只需要简单">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《Python面向对象编程指南》——1.5　通过工厂函数调用__init()__</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>1.5　通过工厂函数调用__init()__</h3>
<p>我们可以使用工厂函数来完成所有Card对象的创建，这比枚举52张牌的方式好很多。在Python中，实现工厂有两种途径。</p>
<ul>
<li>定义一个函数，返回不同类的对象。</li>
<li>定义一个类，包含了创建对象的方法。这是完整的工厂设计模式，正如设计模式书中提到的。在类似Java这样的语言里，工厂类层次结构是必需的，因为语言本身不支持可以脱离类而单独存在的函数。</li>
</ul>
<p>在Python里，类定义不是必需的。仅当特别复杂的情形，工厂类才是不错的选择。Python的优势之一是，对于只需要简单地定义一个函数就能做到的事情没必要去定义类层次结构。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2IyZWE1MGUwYjBlOWI4OWU4ZWM0YWQ2ODQ0NmEwZTYxNDE3ZTkwNDgucG5n.jpg"></p>
<p>如果需要，我们总可以将函数重写为合适的可调用对象。进行工厂模式设计时，也可以将可调用对象进一步重构为工厂类的层次结构。我们将在第5章“可调用对象和上下文的使用”中详细介绍可调用对象。</p>
<p>从大体上来看，类定义的优势是：可以通过继承来使得代码可以被更好地重用。工厂类封装了类本身的层次结构以及对象构建的复杂过程。对于已有的工厂类，可以通过添加子类的方式来完成扩展，这样就获得了工厂类的多态设计，不同的工厂类名有相同的方法签名并可以在调用时通过替换对象来改变具体实现。</p>
<p>这种类级别的多态机制对于类似Java和C++这样的编译型语言来说是非常有用的，可以在编译器在生成目标代码时决定类和方法的实现细节。</p>
<p>如果可替代的工厂类并没有重用任何代码，那么类层次结构在Python中并没有多大作用，完全可以使用函数来替代。</p>
<p>以下是用来生成Card子类对象的一个工厂函数的例子。</p>
<pre><code>def card( rank, suit ):
　　if rank == 1: return AceCard( 'A', suit )
　　elif 2 &lt;= rank &lt; 11: return NumberCard( str(rank), suit )
　　elif 11 &lt;= rank &lt; 14:
　　　　name = { 11: 'J', 12: 'Q', 13: 'K' }[rank]
　　　　return FaceCard( name, suit )
　　else:
　　　　raise Exception( "Rank out of range" )</code></pre>
<p>这个函数通过传入牌面值rank和花色值suit来创建Card对象。这样一来，创建对象的工作更简便了。我们已经把创造对象的过程封装在了单独的工厂函数内，外界无需了解对象层次结构以及多态的工作细节就可以通过调用工厂函数来创建对象。</p>
<p>如下代码演示了如何使用工厂函数来构造deck对象。</p>
<pre><code>deck = [card(rank, suit)
　　for rank in range(1,14)
　　　　for suit in (Club, Diamond, Heart, Spade)]</code></pre>
<p>这段代码枚举了所有牌面值和花色的牌，完成了52张牌对象的创建。</p>
<h3>1.5.1　错误的工厂设计和模糊的else语句</h3>
<p>这里需要注意card()函数里的if语句。并没有使用一个catch-all else语句做一些其他步骤，而只是单纯地抛出了一个异常。像这样的catch-all else语句的使用方式是有争议的。</p>
<p>一方面，else语句不能不做任何事情，因为这将隐藏微小的设计错误。另一方面，一些else语句的意图已经很明显了。</p>
<p>因此，避免模糊的else语句是非常重要的。</p>
<p>关于这一点，可以参照以下工厂函数的定义。</p>
<pre><code>def card2( rank, suit ):
　　if rank == 1: return AceCard( 'A', suit )
　　elif 2 &lt;= rank &lt; 11: return NumberCard( str(rank), suit )
　　else:
　　　　name = { 11: 'J', 12: 'Q', 13: 'K' }[rank]
　　　　return FaceCard( name, suit )</code></pre>
<p>创建纸牌对象可以通过如下代码实现。</p>
<pre><code>deck2 = [card2(rank, suit) for rank in range(13) for suit in (Club,
Diamond, Heart, Spade)]</code></pre>
<p>这是最好的方式吗？如果if条件更复杂些呢？</p>
<p>一些程序员可以很快理解这样的if语句，而另一些则会纠结于是否要对if语句的逻辑做进一步划分。</p>
<p>作为高级的Python程序员，我们不应该把else语句的意图留给读者去推断，条件语句的意图应当是非常直接的。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzk2ZTZjOGE4ODEyNjRhYTllZTYxNDA0YWE3Nzg5YWFhMDVhMDE3MDAucG5n.jpg"></p>
<h3>1.5.2　使用elif简化设计来获得一致性</h3>
<p>工厂方法card()中包括了两个很常见的结构。</p>
<ul>
<li>if-elif序列。</li>
<li>映射。</li>
</ul>
<p>为了简单化，重构将是更好的选择。</p>
<p>我们总可以使用elif条件语句代替映射。（是的，总可以。反过来却不行；把elif条件转换为映射有时是有风险的。）</p>
<p>以下是没有使用映射Card工厂类的实现。</p>
<pre><code>def card3( rank, suit ):
　　if rank == 1: return AceCard( 'A', suit )
　　elif 2 &lt;= rank &lt; 11: return NumberCard( str(rank), suit )
　　elif rank == 11:
　　　　return FaceCard( 'J', suit )
　　elif rank == 12:
　　　　return FaceCard( 'Q', suit )
　　elif rank == 13:
　　　　return FaceCard( 'K', suit )
　　else:
　　　　raise Exception( "Rank out of range" )</code></pre>
<p>这里重写了card()工厂方法，将映射转换为了elif语句。比起前一个版本，这个函数在实现上获得了更好的一致性。</p>
<h3>1.5.3　使用映射和类来简化设计</h3>
<p>在一些情形下，可以使用映射而非这样的一个elif条件语句链。如果认为使用一个elif条件语句链是表达逻辑的唯一明智的方式，那么很容易会发现，它看起来很复杂。对于简单的情形，做同样的事情采用映射完成的代码可以更好地工作，而且代码的可读性也更强。</p>
<p>由于类是第1级别的对象，从rank参数映射到对象是很容易的事情。</p>
<p>这个Card工厂类就是使用映射实现的版本。</p>
<pre><code>def card4( rank, suit ):
　　class_= {1: AceCard, 11: FaceCard, 12: FaceCard,
　　　　13: FaceCard}.get(rank, NumberCard)
　　return class_( rank, suit )</code></pre>
<p>我们把rank映射为对象，然后又把rank值和suit值作为参数传入Card构造函数来创建Card实例。</p>
<p>也可以使用一个defaultdict类，然而比起简单的静态映射其实并没有简化多少。下例就是它的实现。</p>
<pre><code>defaultdict( lambda: NumberCard, {1: AceCard, 11: FaceCard, 12:
FaceCard, 13: FaceCard} )</code></pre>
<p>defaultdict类的默认构造函数必须是无参的。我们使用了一个lambda构造函数作为常量的封装函数。这个函数有个很明显的缺陷，缺少从1到A和13到K的映射。当试图添加这段代码逻辑时，就遇到了个问题。</p>
<p>我们需要修改映射逻辑，除了提供Card子类，还需要提供rank对象的字符串结果。如何实现这两部分的映射？有4种常见的方案。</p>
<ul>
<li>可以建立两个并行的映射。此处并不推荐这种做法，后面的章节会说明为什么这样做是不值得的。</li>
<li>可以映射为一个二元组。当然，这个方案也有一些弊端。</li>
<li>可以映射为partial()函数。partial()函数是fun``ctools模块的一个功能。</li>
<li>也可以考虑修改类定义来完成映射逻辑。在下一节里会介绍如何在子类中重写__init()__函数来完成这个方案。</li>
</ul>
<p>对于每个方案我们会通过具体示例逐一演示。</p>
<p>1．并行映射</p>
<p>以下是此方案代码的基本实现。</p>
<pre><code>class_= {1: AceCard, 11: FaceCard, 12: FaceCard, 13: FaceCard
}.get(rank, NumberCard)
rank_str= {1:'A', 11:'J', 12:'Q', 13:'K'}.get(rank,str(rank))
return class_( rank_str, suit)</code></pre>
<p>这样是不值得的。这种实现方式带来了映射键1、11、12和13的逻辑重复。重复是糟糕的，因为软件更新后通常会带来对并行结构多余的维护成本。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzA4MTQyZDhkZDM2NDdlMDEyODQ3MGJlOTQ4MjI3ODMzN2RmYTBiYTQucG5n.jpg"></p>
<p>2．映射到一个牌面值的元组</p>
<p>以下代码演示了如何映射到二元组的基本实现。</p>
<pre><code>class_, rank_str= {
　　1:　 (AceCard,'A'),
　　11: (FaceCard,'J'),
　　12: (FaceCard,'Q'),
　　13: (FaceCard,'K'),
　　}.get(rank, (NumberCard, str(rank)))
return class_( rank_str, suit )</code></pre>
<p>这个方案看起来还不错。并没有太多代码来完成特殊情形的处理。接下来我们会看到当需要修改Card类层次结构时：添加一个Card子类时，如何来修改和扩展。</p>
<p>从rank值映射为类对象是很少见的，而且两个参数中只有一个用于对象的初始化。从rank映射到一个相对简单的类或函数对象，而不必提供目的不明确的参数，这才是明智的选择。</p>
<p>3．partial函数设计</p>
<p>除了映射到二元组函数和只提供一个参数来实例化的方案外，我们还可以创建partial()函数。这个函数可以用来实现可选参数。我们会从functools库中使用partial()函数创建一个带有rank参数的部分类。</p>
<p>以下演示了如何建立从rank到partial()函数的映射来完成对象的初始化。</p>
<pre><code>from functools import partial
part_class= {
　　1: partial(AceCard,'A'),
　　11: partial(FaceCard,'J'),
　　12: partial(FaceCard,'Q'),
　　13: partial(FaceCard,'K'),
　　}.get(rank, partial(NumberCard, str(rank)))
return part_class( suit )</code></pre>
<p>通过调用partial()函数然后赋值给part<code>_</code>class，完成了与rank对象的关联。可以使用同样的方式创建suit对象，并完成最终Card对象的创建。partial()函数的使用在函数式编程中是很常见的，当使用的是函数而非对象方法的时候就可以考虑使用。</p>
<p>大致上，partial()函数在面向对象编程中不是很常用。我们可以简单地提供构造函数的不同版本来做同样的事情。partial()函数和构造对象时的流畅接口很类似。</p>
<p>4．工厂模式的流畅API设计</p>
<p>有时我们定义在类中的方法必须按特定的顺序来调用。这种按顺序调用的方法和创建partial()函数的方式非常类似。</p>
<p>假如有这样的函数调用x.a().b()。对于x(a,b)这个函数，放在partial()函数的实现就可以是先调用x.a()再调用b()函数，这种方式可以理解为x(a)(b)。</p>
<p>这意味着Python在管理状态方面提供了两种选择。我们可以直接更新对象或者对具有状态的对象使用partial()函数。由于两种方式是等价的，因而可以把partial()函数重构为工厂对象创建的流畅接口。我们在流畅接口函数中设置可以反馈self值的rank对象，然后传入花色类从而创建Card实例。</p>
<p>如下是Card工厂流畅接口的定义，包含了两个函数，它们必须按顺序调用。</p>
<pre><code>class CardFactory:
　　def rank( self, rank ):
　　　　self.class_, self.rank_str= {
　　　　　　1:(AceCard,'A'),
　　　　　　11:(FaceCard,'J'),
　　　　　　12:(FaceCard,'Q'),
　　　　　　13:(FaceCard,'K'),
　　　　　　}.get(rank, (NumberCard, str(rank)))
　　　　return self
　　def suit( self, suit ):
　　　　return self.class_( self.rank_str, suit)</code></pre>
<p>先是使用rank()函数更新了构造函数的状态，然后通过suit()函数创造了最终的Card对象。</p>
<p>这个工厂类可以以如下方式来使用。</p>
<pre><code>card8 = CardFactory()
deck8 = [card8.rank(r+1).suit(s) for r in range(13) for s in (Club,
Diamond, Heart, Spade)]</code></pre>
<p>我们先实例化一个工厂对象，然后再创建Card实例。这种方式并没有利用__init()__在Card类层次结构中的作用，改变的是调用者创建对象的方式。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-27 00:21:54</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e9%9d%a2%e5%90%91%e5%af%b9%e8%b1%a1%e7%bc%96%e7%a8%8b/" title="面向对象编程">面向对象编程</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《Python面向对象编程指南》——1.5　通过工厂函数调用__init()__的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEQ7nPb.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;1&period;4　使用&lowbar;&lowbar;init&lpar;&rpar;&lowbar;&lowbar;方法创建常量清单</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 使用__init()__方法创建常量清单 我们可以为所有卡片的花色单独创建一个类.可在21点应用中,花色不是很重要,用一个字母来代替就可以. 这里使用花色的初始化作为创建常量对象的一个实例.很多情况下,应用会包括一个常量集合.静态常量也正构成了策略(Strategy)或状态(State)模式的一部分. 有些情况下,常量会在应用或配置文件的初始化阶段被创建.或者创建变量的行为是基于命令行参数的.我们会在第16章&quot;使用命令行&quot;中介绍应用初始化和启动的详细设计过程. Python中并			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPLG0mp.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前 言 本书主要介绍Python语言的高级特性,特别是如何编写高质量的Python程序.这通常意味着编写高性能且拥有良好可维护性的程序.同时,我们也会探究不同的设计方案并确定究竟是哪种方案提供了最佳性能.而对于一些正在寻找解决方案的问题,这也是一种很好的方式. 本书的大部分内容将介绍一种给定设计的不同替代方案.一些方案性能更好,另一些方案更加简单或者更加适合于特定领域的问题.最重要的是,找到最好的算法和最优的数据结构,以最少的开销换取最大的价值.时间就是金钱,高效的程序会为它们的用户创造更多的价			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5RQ1qz.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;第1部分 用特殊方法实现Python风格的类  第1章　&lowbar;&lowbar;init&lowbar;&lowbar;&lpar;&rpar;方法  1&period;1　隐式的基类&mdash;&mdash;object</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1部分 用特殊方法实现Python风格的类 init()方法 与Python无缝集成--基本特殊方法 属性访问.特性和修饰符 抽象基类设计的一致性 可调用对象和上下文的使用 创建容器和集合 创建数值类型 装饰器和Mixins--横切方面 用特殊方法实现 Python风格的类 通过重写特殊方法来完成对Python内部机制的调用,在Python中是很普遍的.例如len()函数就可以重写一个类的__len__()方法. 这意味着对于像(len(x))这样的通用公共接口,任何类(例如,声明一个类叫ti			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQj2aKM.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;1&period;3　在基类中实现init&lpar;&rpar;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 在基类中实现init()方法 通过实现__init()__方法来初始化一个对象.每当创建一个对象,Python会先创建一个空对象,然后调用该对象的__init()__函数.这个方法提供了对象内部变量以及其他一些一次性过程的初始化操作. 以下是关于一个Card类层次结构定义的一些例子.这里定义了一个基类和3个子类来描述Card类的基本信息.有两个变量是参数直接赋值的,另外两个参数是通过初始化方法计算来完成初始化的. class Card: def __init__( self, rank,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p52jQRz.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;1&period;6　在每个子类中实现&lowbar;&lowbar;init&lpar;&rpar;&lowbar;&lowbar;方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.6 在每个子类中实现__init()__方法 正如介绍工厂函数那样,这里我们也先看一些Card类的设计实例.我们可以考虑重构rank数值转换的代码,并把这个功能加在Card类上.这样就可以把初始化的工作分发到每个子类来完成. 这通常需要在基类中完成一些公共的初始化逻辑,子类中完成各自特殊的初始化逻辑.我们需要遵守不要重复自己(Don't Repeat Yourself,DRY)的原则来防止子类中的代码重复. 以下代码演示了如何把初始化职责分发到各自的子类中. class Card: pass			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK8NG5M.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;1&period;7　简单的组合对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.7 简单的组合对象 一个组合对象也可以称作容器.我们会从一个简单的组合对象开始介绍:一副牌.这是一个基本的集合对象.我们的确可以简单地使用一个list来代替一副牌(deck)对象. 在设计一个类之前,我们需要考虑这样的一个问题:简单地使用list是合适的做法吗? 可以使用random.shuffle()函数完成洗牌操作,使用deck.pop()来完成发牌操作. 一些程序员可能会过早定义新类,正如像使用内置类一样,违反了一些面向对象的设计原则.比如像下面的这个设计. d= [card6(r+1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQkl7Kp.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;1&period;12　更多的&lowbar;&lowbar;init&lowbar;&lowbar;&lpar;&rpar;技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.12 更多的__init__()技术 我们再来看一下其他一些更高级的__init__()技术的应用.相比前面的介绍,它们的应用场景不是特别常见. 以下是Player类的定义,初始化使用了两个策略对象和一个table对象.这个__init__()函数看起来不够漂亮. class Player: def __init__( self, table, bet_strategy, game_strategy ): self.bet_strategy = bet_strategy self.game_			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX94P4z.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;2&period;6　比较运算符方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.6 比较运算符方法 Python有6个比较运算符.这些运算符分别对应一个特殊方法的实现.根据文档,运算符和特殊方法的对应关系如下所示. x &lt; y调用x.__lt__(y). x &lt;=y调用x.__le__(y). x == y调用x.__eq__(y). x != y调用x.__ne__(y). x &gt; y调用x.__gt__(y). x &gt;= y调用x.__ge__(y). 我们会在第7章&quot;创建数值类型&quot;中再探讨比较运算符. 对于实际上使用了哪个比较运算			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8k7Z9M.html" rel="bookmark">《Python面向对象编程指南》&mdash;&mdash;2&period;8　&lowbar;&lowbar;new&lowbar;&lowbar;&lpar;&rpar;方法和不可变对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.8 __new__()方法和不可变对象 __new__方法的一个用途是初始化不可变对象.__new__()方法中允许创建未初始化的对象.这允许我们在__init__()方法被调用之前先设置对象的属性. 由于不可变类的__init__()方法很难重载,因此__new__方法提供了一种扩展这种类的方法. 下面是一个错误定义的类,我们定义了float的一个包含单位信息的版本. class Float_Fail( float ): def __init__( self, value, unit ):			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7QZZb.html" rel="bookmark" class="title">多接口主机IP路由配置</a>
					<div>
						我校校园网是教科网的一个节点,开设了两个出口,一个是教科网出口,一个 是电信网出口.网络出口的选择策略是:访问教科网公布的免费地址列表中的节 点时走教科网出口,否则通过代理服务器走电信网出口.由于教科 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7Ygdb.html" rel="bookmark" class="title">感受Windows 2003域更名工具</a>
					<div>
						域更名工具(Domain Rename Tools)是 Windows Server 2003 为顺应用户需求而新增的一个网络维护工具.该工具极大地减轻了网管在Windows NT和Windows 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOYykM.html" rel="bookmark" class="title">PHP开发框架Yii Framework教程&lpar;9&rpar; UI小组件Widget概述</a>
					<div>
						和通常的应用程序开发框架一样,Yii Framework也提供了一组UI小组件(CWidget)来帮助程序员设计用户界面,小组是 CWidget 或其子类的实例.它是一个主要用于表现数据的组件.小组通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2m0Zp.html" rel="bookmark" class="title">Android为ListView的Item设置不同的布局</a>
					<div>
						  MainActivity如下: package cc.testlistview; import java.util.ArrayList; import java.util.HashMap; imp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3wDyp.html" rel="bookmark" class="title">Dolphin模拟器怎么用</a>
					<div>
						Dolphin的前身是一款NGC模拟器,在重新改制后已经可以在中等配置PC上全速模拟绝大多数Wii游戏,尤其可以支持原生Wii控制器,是玩家首选的Wii模拟器.就目前来说,Wii模拟器Dolphin已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaa5vz.html" rel="bookmark" class="title">Photoshop给人物照片增加淡美的阳光色</a>
					<div>
						阳光色重点是高光的把握,调色过程也非常简单:先把图片整体颜色调淡,高光部分增加一些暖色,然后选择一个合适的角度加上类似阳光的高光即可. 原图 &lt;点小图查看大图&gt; photoshop教程最终 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24Wq3p.html" rel="bookmark" class="title">JavaScript中按位&OpenCurlyDoubleQuote;异或&rdquo;运算符使用介绍</a>
					<div>
						 按位&quot;异或&quot;运算符 (^)是对两个表达式执行按位异或,下面为大家介绍下其具体的使用方法 按位&quot;异或&quot;运算符 (^)是对两个表达式执行按位异或.使用方法:  代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3odGwb.html" rel="bookmark" class="title">输入法不能切换解决方法</a>
					<div>
						  输入法不能切换解决方法 输入法切换不了怎么办 输入法切换不了怎么办?我们都知道用&quot;Crtl&quot;+&quot;Shift&quot;可以切换输入法,但是有时候切换不了是什么回事呢? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGAQLOM.html" rel="bookmark" class="title">别再管什么用户体验了（转）</a>
					<div>
						创见干货:初创公司在刚起步时通常各类问题一起涌来,其中用户体验问题难免令创业者抓耳挠腮.搞初创的朋友经常不自觉地关注用户对产品的看法,然而这一切其实只是浪费精力,放心地去关注产品开发.资金筹集.团队建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAEn2M.html" rel="bookmark" class="title">docker 存储池扩容方案</a>
					<div>
						先来看看 docker devicemapper 插件工作原理吧 它是基于 Device Mapper 的&quot;精简目标&quot;的特性.它实际上是目标块设备的快照,之所以被称为&quot;精 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QvYPp.html" rel="bookmark" class="title">MySQL 加锁处理分析</a>
					<div>
						首先声明,本文转载自:http://hedengcheng.com/?p=771#_Toc374698320 1    背景    1 1.1    MVCC:Snapshot Read vs Cur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEoRYp.html" rel="bookmark" class="title">getname-android BluetoothAdapter</a>
					<div>
						问题描述 android BluetoothAdapter 为什么不为空的BluetoothAdapter的getName和getAddress两个方法的返回结果为空 解决方案 BluetoothAd ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ3OZz.html" rel="bookmark" class="title">Redefine：Change in the Changing World</a>
					<div>
						EMC World 2014的主题就是REDEFINE.的确,现在科技的发展在重新定义了技术,影响了生活,改变了你我. 对于一个有数万员工,甚至数十万员工的企业来说,Redefine无疑更加具有挑战, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqjXKz.html" rel="bookmark" class="title">android自定义view-Android在自定义View控制Activity里控件</a>
					<div>
						问题描述 Android在自定义View控制Activity里控件 最近在学习Android,想做一个效果遇到了困难.我自定义了一个View,然后在View里设置触摸事件,点击一个出现一个按钮, 再点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX42Vz.html" rel="bookmark" class="title">Java并发专题 带返回结果的批量任务执行 CompletionService ExecutorService&period;invokeAll（转）</a>
					<div>
						转载请标明出处:http://blog.csdn.net/lmj623565791/article/details/27250059 一般情况下,我们使用Runnable作为基本的任务表示形式,但是R ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK57J5p.html" rel="bookmark" class="title">微软企业统一通信解决方案</a>
					<div>
						什么是统一沟通 1. http://www.aliyun.com/zixun/aggregation/11208.html&quot;&gt;Microsoft 统一沟通技术为客户如何提供.管理和维护 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLxjVM.html" rel="bookmark" class="title">seconnection-java 连接sde内存溢出 arcgis</a>
					<div>
						问题描述 java 连接sde内存溢出 arcgis SeLayer insertLayer=null; SeConnection conn=null; try { conn = new SeConn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqQGVb.html" rel="bookmark" class="title">请达人看下这程序</a>
					<div>
						问题描述 protectedvoidPage_Load(objectsender,EventArgse){stringconstr=ConfigurationManager.ConnectionStr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baB3RgM.html" rel="bookmark" class="title">鲁南大宗提醒创业者 如何防止诈骗信息</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   随着网络时代的飞速发展,网络 营销成为现代人最理想的事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrqk8Wb.html" rel="bookmark" class="title">百度api-百度地图 怎么实现附近的办公楼</a>
					<div>
						问题描述 百度地图 怎么实现附近的办公楼 我建一个网页 想调用百度地图 我输入一个办公楼的名字 然后会出现以这个办公楼为中心的其他的办公楼 然后随便点击一个 我获取到他点击的这个楼的id 存入数据库  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eEkLb.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;云保护&rdquo;技术不可少</a>
					<div>
						在记者看来,&quot;云计算老,云安全新&quot;,已经成为不争的事实.但这一老一新如何能让用户放心使用,需要走的路还很长.事实上,从2008年底,IDC.Gartner等咨询机构纷纷作出了安全厂 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvne25M.html" rel="bookmark" class="title">苹果中国官网推出免息分期付款计划</a>
					<div>
						正在中国访问的苹果公司CEO蒂姆·库克透露,在未来几年,苹果将在华开设更多零售商店,他希望将来可以到中国首发苹果新产品.从&quot;无视&quot;中国市场,不到两年内公司CEO两度访华,中国作为苹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBVEqM.html" rel="bookmark" class="title">《趣学JavaScript&mdash;&mdash;教孩子学编程》&mdash;&mdash;2&period;5　undefined和null</a>
					<div>
						2.5 undefined和null 最后,还有不属于任何特殊情况的两个值.它们是undefined和null.用它们来表示&quot;没有&quot;,但是,它们之间略有不同. JavaScript ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAEOVAM.html" rel="bookmark" class="title">《R语言数据分析》&mdash;&mdash;2&period;2　其他流行的在线数据格式</a>
					<div>
						本节书摘来自华章出版社&lt;R语言数据分析&gt;一书中的第2章,第2.2节,作者盖尔盖伊·道罗齐(Gergely Daróczi),潘怡 译,更多章节内容可以访问&quot;华章计算机&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Y4oxz.html" rel="bookmark" class="title">企业圈地：搭建平台 实现垂直整合</a>
					<div>
						在CES开展前,智能家居一直倍受关注,但让人遗憾的是,它并没有借助CES大放异彩.无论是三星.LG还是海尔.海信.长虹,参展的企业更侧重展示电视机.冰箱.洗衣机等产品功能的应用,例如,LG现场展示了b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrGevp.html" rel="bookmark" class="title">MySQL转换Oracle的需要注意的七个事项&lowbar;Mysql</a>
					<div>
						下面总结出MySQL转换Oracle的几点注意事项,希望对大家有所帮助. 1．自动增长的数据类型处理 MySQL有自动增长的数据类型,插入记录时不用操作此字段,会自动获得数据值.Oracle没有自动增 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2nVyM.html" rel="bookmark" class="title">JSP页面间传值问题实例简析&lowbar;JSP编程</a>
					<div>
						本文实例分析了JSP页面间传值问题.分享给大家供大家参考,具体如下: 其中最简单的要数&lt;a&gt;标签里面的href来传值了, 在a.jsp中写: &lt;a href=&quot;b.jsp? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNx6Vp.html" rel="bookmark" class="title">C&num;窗体中重写WndProc方法为什么可以截获鼠标单击消息，却不能截获键盘按键消息？</a>
					<div>
						问题描述 如下,可以截获到鼠标单击消息:protectedoverridevoidWndProc(refMessagem){constintWM_MOUSEDOWN=0x0210;if(m.Msg== ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7wkxKz.html" rel="bookmark" class="title">jQuery中的removeClass问题</a>
					<div>
						问题描述 $('p').addClass(&quot;test&quot;);$('p').removeClass(&quot;test&quot;);$('p').hasClass(&quot;te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyK3e5z.html" rel="bookmark" class="title">websphere mq 报错： MQJE001&colon; 完成代码为 &amp;amp&semi;amp&semi;&num;x27&semi;2&amp;amp&semi;amp&semi;&num;x27&semi;，原因为 &amp;amp&semi;amp&semi;&num;x27&semi;2539&amp;amp&semi;amp&semi;&num;x27&semi;。</a>
					<div>
						问题描述 刚在本地上安装了webspheremqv7,安装之后建立了队列管理器.队列和通道然后编写java代码,想mq发送消息,就报这个错误,一下是java代码packagetest.mq;impor ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
